--
-- FB_top.vhd
-- Author : David Humphrey (dave.humphrey@csiro.au)
-- Description
--  Top level for the perentie filterbanks. Includes :
--   - Correlator filterbank - 4096 point FFT, 12 tap FIR filter, 4 streams simultaneously.
--   - PSS filterbank - 64 point FFT, 12 tap FIR filter, 6 streams simultaneously.
--   - PST filterbank - 256 point FFT, 12 tap FIR filter, oversampled by 4/3, 6 streams simultaneously.
--   - MACE interface, which is just to allow reading/writing of the filter taps in the filterbanks.
--     *** WARNING *** MACE slave is manually written. MACE slave module is NOT auto-generated by ARGS. 
--     Changing the yaml file will not change the actual registers.
--     This is to allow the memories to reside in the filters, rather than being pulled out and put into 
--     ARGs. 
--
----------------------------------------------------------------------------------------------------------
library IEEE, axi4_lib, common_lib, filterbanks_lib, dsp_top_lib;
--use ctc_lib.ctc_pkg.all;
use dsp_top_lib.dsp_top_pkg.all;
use common_lib.common_pkg.all;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use axi4_lib.axi4_lite_pkg.ALL;
use axi4_lib.axi4_full_pkg.ALL;
--USE filterbanks_lib.filterbanks_reg_pkg.ALL;

entity FB_Top_PST is
    port(
        -- clock, target is 450 MHz
        i_data_clk  : in std_logic;
        i_data_rst  : in std_logic;
        -- Configuration (on i_data_clk)
        i_fineDelayDisable : in std_logic;
        i_RFIScale         : in std_logic_vector(4 downto 0);
        --------------------------------------------------------
        -- PSS and PST Data input, common valid signal, expects packets of 64 samples. 
        -- Requires at least 2 clocks idle time between packets.
        -- Due to oversampling, also requires on average 86 clocks between packets - specifically, no more than 3 packets in 258 clocks.
        i_SOF         : in std_logic; 
        i_data0 : in t_slv_8_arr(1 downto 0);  -- 6 Inputs, each complex data, 8 bit real, 8 bit imaginary.
        i_data1 : in t_slv_8_arr(1 downto 0);
        i_meta01 : in t_atomic_CT_pst_META_out; -- .HDeltaP(15:0), .VDeltaP(15:0), .frameCount(36:0), virtualChannel(15:0), .valid
        i_data2 : in t_slv_8_arr(1 downto 0);
        i_data3 : in t_slv_8_arr(1 downto 0);
        i_meta23 : in t_atomic_CT_pst_META_out; -- .HDeltaP(15:0), .VDeltaP(15:0), .frameCount(36:0), virtualChannel(15:0), .valid
        i_data4 : in t_slv_8_arr(1 downto 0);
        i_data5 : in t_slv_8_arr(1 downto 0);
        i_meta45 : in t_atomic_CT_pst_META_out; -- .HDeltaP(15:0), .VDeltaP(15:0), .frameCount(36:0), virtualChannel(15:0), .valid
        i_DataValid   : in std_logic;
        -----------------------------------------------------------
        -- PST filterbank data output
        o_frameCount     : out std_logic_vector(36 downto 0); -- frame count is the same for all simultaneous output streams.
        o_virtualChannel : out t_slv_16_arr(2 downto 0); -- 3 virtual channels, one for each of the PST data streams.
        o_HeaderValid : out std_logic_vector(2 downto 0);
        -- Data coming in on i_data0 goes out as real = o_data(0)(47:32), imaginary = o_data(0)(63:48)
        --                   i_data1  -->        real = o_data(0)(15:0), imaginary = o_data(0)(31:16) 
        --                   i_data2  -->        real = o_data(1)(47:32), imaginary = o_data(1)(63:48)
        --                   i_data3  -->        real = o_data(1)(15:0), imaginary = o_data(1)(31:16) 
        -- etc for i_data4, i_data5.
        o_Data        : out t_slv_64_arr(2 downto 0);    -- 3 dual-pol samples, 16+16 complex.
        o_DataValid   : out std_logic
    );
end FB_Top_PST;

architecture Behavioral of FB_Top_PST is
    
    signal PSSPSTMetaIn, PSTMetaOut : std_logic_vector(471 downto 0);
    signal PSTDout0, PSTDout1, PSTDout2, PSTDout3, PSTDout4, PSTDout5 : t_slv_16_arr(1 downto 0);
    signal PSTValidOut, PSTValidOutDel : std_logic;
    
    signal data0, data1, data2, data3, data4, data5 : t_slv_8_arr(1 downto 0);  -- 6 Inputs, each complex data, 8 bit real, 8 bit imaginary.  

    signal PSTDout_arr : t_FB_output_payload_a(2 downto 0);
    signal PSTFBHeader : t_atomic_CT_pst_META_out_arr(2 downto 0);
    signal PSTFBHeaderValid : std_logic;
    signal FDPSTHeaderValid : std_logic_vector(2 downto 0);
    signal FDPSTDataValid : std_logic_vector(2 downto 0);
    signal FDHeader : t_atomic_CT_pst_META_out_arr(2 downto 0);
    signal DataValid : std_logic;
    
begin
    
    -----------------------------------------------------------------------------------
    -- PST Filterbank
    process(i_data_clk)
    begin
        if rising_edge(i_data_clk) then
            PSSPSTMetaIn(31 downto 0) <= i_meta01.HDeltaP;
            PSSPSTMetaIn(63 downto 32) <= i_meta01.VDeltaP;
            PSSPSTMetaIn(95 downto 64) <= i_meta01.HOffsetP;
            PSSPSTMetaIn(127 downto 96) <= i_meta01.VOffsetP;
            PSSPSTMetaIn(143 downto 128) <= i_meta01.virtualChannel;
            PSSPSTMetaIn(144) <= i_meta01.valid; -- note that .valid is just a qualifier for the meta data. The meta data is only valid if both this and i_datavalid are high.
            
            PSSPSTMetaIn(31+145 downto 0+145) <= i_meta23.HDeltaP;
            PSSPSTMetaIn(63+145 downto 32+145) <= i_meta23.VDeltaP;
            PSSPSTMetaIn(95+145 downto 64+145) <= i_meta23.HOffsetP;
            PSSPSTMetaIn(127+145 downto 96+145) <= i_meta23.VOffsetP;
            PSSPSTMetaIn(143+145 downto 128+145) <= i_meta23.virtualChannel;
            PSSPSTMetaIn(144+145) <= i_meta23.valid;
            
            PSSPSTMetaIn(31+290 downto 0+290) <= i_meta45.HDeltaP;
            PSSPSTMetaIn(63+290 downto 32+290) <= i_meta45.VDeltaP;
            PSSPSTMetaIn(95+290 downto 64+290) <= i_meta45.HOffsetP;
            PSSPSTMetaIn(127+290 downto 96+290) <= i_meta45.VOffsetP;
            PSSPSTMetaIn(143+290 downto 128+290) <= i_meta45.virtualChannel;
            PSSPSTMetaIn(144+290) <= i_meta45.valid;
            
            PSSPSTMetaIn(36+435 downto 0+435) <= i_meta01.frameCount;  -- framecount is the same for all input headers. Total of 37+3*81 = 280 header bits.
            
            -- !!!! Just replace RFI with zeros; We also need to do something to flag the output of the filterbank if the input data was flagged. 
            for i in 0 to 1 loop
                if i_data0(i) = x"80" then
                    data0(i) <= x"00";
                else
                    data0(i) <= i_data0(i);
                end if;
                if i_data1(i) = x"80" then
                    data1(i) <= x"00";
                else
                    data1(i) <= i_data1(i);
                end if;
                if i_data2(i) = x"80" then
                    data2(i) <= x"00";
                else
                    data2(i) <= i_data2(i);
                end if;
                if i_data3(i) = x"80" then
                    data3(i) <= x"00";
                else
                    data3(i) <= i_data3(i);
                end if;
                if i_data4(i) = x"80" then
                    data4(i) <= x"00";
                else
                    data4(i) <= i_data4(i);
                end if;
                if i_data5(i) = x"80" then
                    data5(i) <= x"00";
                else
                    data5(i) <= i_data5(i);
                end if;
                
            end loop;
            DataValid <= i_DataValid;
        end if;
    end process;
    
    pstfbi : entity filterbanks_lib.PSTFBTop
    generic map(
        METABITS => 472,    -- Width in bits of the meta_i and meta_o ports.
        FRAMESTODROP => 15  -- Number of output frames to drop after a reset (to account for initialisation of the filterbank)
    )
    port map (
        -- processing clock
        clk         => i_data_clk,
        rst         => i_SOF,
        -- Data input, common valid signal, expects packets of 64 samples. 
        -- Requires at least 2 clocks idle time between packets.
        -- Due to oversampling, also requires on average 86 clocks between packets - specifically, no more than 3 packets in 258 clocks. 
        data0_i => data0, -- in t_slv_8_arr(1 downto 0);  -- 6 Inputs, each complex data, 8 bit real, 8 bit imaginary.
        data1_i => data1, -- in t_slv_8_arr(1 downto 0);
        data2_i => data2, -- in t_slv_8_arr(1 downto 0);
        data3_i => data3, -- in t_slv_8_arr(1 downto 0);
        data4_i => data4, -- in t_slv_8_arr(1 downto 0);
        data5_i => data5, -- in t_slv_8_arr(1 downto 0);
        meta_i  => PSSPSTMetaIn, -- in std_logic_vector((METABITS-1) downto 0);  -- Sampled on the first cycle of every third packet of valid_i. 
        valid_i => DataValid, -- in std_logic;
        -- Data out; bursts of 216 clocks for each channel.
        data0_o => PSTDout0,    -- out t_slv_16_arr(1 downto 0);   -- 6 outputs, real and imaginary parts in (0) and (1) respectively;
        data1_o => PSTDout1,    -- out t_slv_16_arr(1 downto 0);
        data2_o => PSTDout2,    -- out t_slv_16_arr(1 downto 0);
        data3_o => PSTDout3,    -- out t_slv_16_arr(1 downto 0);
        data4_o => PSTDout4,    -- out t_slv_16_arr(1 downto 0);
        data5_o => PSTDout5,    -- out t_slv_16_arr(1 downto 0);
        meta_o  => PSTMetaOut,  -- out std_logic_vector((METABITS-1) downto 0);
        valid_o => PSTValidOut  -- out std_logic;
    );
    

    -- Pack the filterbank output into a structure for input to the fine delay module.
    PSTDout_arr(0).vpol.re <= PSTDout0(0);  -- 16 bit data into the fine delay module.
    PSTDout_arr(0).vpol.im <= PSTDout0(1);
    PSTDout_arr(0).hpol.re <= PSTDout1(0);
    PSTDout_arr(0).hpol.im <= PSTDout1(1);
    PSTDout_arr(1).vpol.re <= PSTDout2(0);  -- 16 bit data into the fine delay module.
    PSTDout_arr(1).vpol.im <= PSTDout2(1);
    PSTDout_arr(1).hpol.re <= PSTDout3(0);
    PSTDout_arr(1).hpol.im <= PSTDout3(1);
    PSTDout_arr(2).vpol.re <= PSTDout4(0);  -- 16 bit data into the fine delay module.
    PSTDout_arr(2).vpol.im <= PSTDout4(1);
    PSTDout_arr(2).hpol.re <= PSTDout5(0);
    PSTDout_arr(2).hpol.im <= PSTDout5(1);
    
    PSTFBHeader(0).HDeltaP <= PSTMetaOut(31 downto 0);
    PSTFBHeader(0).VDeltaP <= PSTMetaOut(63 downto 32);
    PSTFBHeader(0).HOffsetP <= PSTMetaOut(95 downto 64);
    PSTFBHeader(0).VOffsetP <= PSTMetaOut(127 downto 96);
    PSTFBHeader(0).virtualChannel <= PSTMetaOut(143 downto 128);
    PSTFBHeader(0).frameCount <= PSTMetaOut(36+435 downto 0+435);
    PSTFBHeader(0).valid <= PSTMetaOut(144);
    
    PSTFBHeader(1).HDeltaP <= PSTMetaOut(31+145 downto 0+145);
    PSTFBHeader(1).VDeltaP <= PSTMetaOut(63+145 downto 32+145);
    PSTFBHeader(1).HOffsetP <= PSTMetaOut(95+145 downto 64+145);
    PSTFBHeader(1).VOffsetP <= PSTMetaOut(127+145 downto 96+145);
    PSTFBHeader(1).virtualChannel <= PSTMetaOut(143+145 downto 128+145);
    PSTFBHeader(1).frameCount <= PSTMetaOut(36+435 downto 0+435);
    PSTFBHeader(1).valid <= PSTMetaOut(144+145);
    
    PSTFBHeader(2).HDeltaP <= PSTMetaOut(31+290 downto 0+290);
    PSTFBHeader(2).VDeltaP <= PSTMetaOut(63+290 downto 32+290);
    PSTFBHeader(2).HOffsetP <= PSTMetaOut(95+290 downto 64+290);
    PSTFBHeader(2).VOffsetP <= PSTMetaOut(127+290 downto 96+290);
    PSTFBHeader(2).virtualChannel <= PSTMetaOut(143+290 downto 128+290);
    PSTFBHeader(2).frameCount <= PSTMetaOut(36+435 downto 0+435);
    PSTFBHeader(2).valid <= PSTMetaOut(144+290);
    
    PSTFBHeaderValid <= PSTValidOut and (not PSTValidOutDel);
    
    process(i_data_clk)
    begin
        if rising_edge(i_data_clk) then
            PSTValidOutDel <= PSTValidOut;
        end if;
    end process;
    
    FDGen : for i in 0 to 2 generate 
        FineDelay : entity filterbanks_lib.fineDelay
        generic map (
            FBSELECTION => 1  -- PST data
        )
        port map (
            i_clk  => i_data_clk,
            -- data and header in
            i_data        => PSTDout_arr(i), --  in t_FB_output_payload;  -- 16 bit data : .Hpol.re, Hpol.im, .Vpol.re, .Vpol.im 
            i_dataValid   => PSTValidOut,    -- in std_logic;
            i_header      => PSTFBHeader(i),   -- in t_atomic_CT_pst_META_out; -- .HDeltaP(15:0), .VDeltaP(15:0), .frameCount(36:0), virtualChannel(15:0), .valid
            i_headerValid => PSTFBHeaderValid, -- in std_logic;
            -- Data and Header out            
            o_data        => o_data(i),      -- out std_logic_vector(63 downto 0);   -- 16+16 complex data, dual pol.
            o_dataValid   => FDPSTDataValid(i), -- out std_logic;
            o_header      => FDHeader(i),       -- out t_atomic_CT_pst_META_out; -- .HDeltaP(15:0), .VDeltaP(15:0), .frameCount(36:0), virtualChannel(15:0), .valid
            o_headerValid => o_headerValid(i), -- out std_logic;
    
            -------------------------------------------
            -- control and monitoring
            -- Disable the fine delay. Instead of multiplying by the output of the sin/cos lookup, just scale by unity.
            i_disable     => i_fineDelayDisable, -- in std_logic;
            -- Scale down by 2^(i_RFIScale) before clipping for RFI.
            -- Unity for the sin/cos lookup is 0x10000, so :
            --   i_RFIScale < 16  ==> Amplify the output of the filterbanks.
            --   i_RFIScale = 16  ==> Amplitude of the filterbank output is unchanged.
            --   i_RFIScale > 16  ==> Amplitude of the filterbank output is reduced.
            i_RFIScale    => i_RFIScale, -- in std_logic_vector(4 downto 0); 
            -- For monitoring of the output level.
            -- Higher level should keep track of : 
            --   * The total number of frames processed.
            --   * The sum of each of the outputs below. (but note one is superfluous since it can be calculated from the total frames processed and the sum of all the others).
            --      - These sums should be 32 bit values, which ensures wrapping will occur at most once per hour.
            -- For the correlator:
            --   - Each frame corresponds to 3456 fine channels x 2 (H & V polarisations) * 2 (re+im).
            --   - Every fine channel must be one of the categories below, so they will sum to 3456*2*2 = 13824.
            o_overflow    => open, -- hist_overflow(i),     -- out(15:0); -- Number of fine channels which were clipped.
            o_64_127      => open, -- hist_64_127(i),  -- out(15:0); -- Number of fine channels in the range 64 to 128.
            o_32_63       => open, -- hist_32_63(i),   -- out(15:0); -- Number of fine channels in the range 32 to 64.
            o_16_31       => open, -- hist_16_31(i),   -- out(15:0); -- Number of fine channels in the range 16 to 32.
            o_0_15        => open, -- hist_0_15(i),    -- out(15:0); -- Number of fine channels in the range 0 to 15.
            o_virtualChannel => open, -- hist_virtualChannel(i), -- out(8:0);
            o_histogramValid => open  -- hist_valid(i) -- out std_logic -- indicates histogram data is valid.
        );
    end generate;
    
    o_dataValid <= FDPSTDataValid(0);  -- FDPSTDataValid(0) and (1) will be the same.
    o_virtualChannel(0) <= FDHeader(0).virtualChannel;
    o_virtualChannel(1) <= FDHeader(1).virtualChannel;
    o_virtualChannel(2) <= FDHeader(2).virtualChannel;
    o_frameCount <= FDHeader(0).frameCount;
    
end Behavioral;